<?php
// extract a final consonant which determines particle used
// these functions support only Korean and English now

function finalConsonant($str) {
	$index = strlen($str) - 1;
	
	while ($index >= 0)
	{
		$value = ord($str[$index]);

		if ($value < 0x80) // ASCII (0xxx xxxx)
		{
			switch ($str[$idx])
			{
				case 'L':
				case 'M':
				case 'N':
				case 'R':
				case 'l':
				case 'm':
				case 'n':
				case 'r':
					return true;
				default:
					return false;
			}
		}

		if ($value & 0x40) // Beginning of a character (1110 xxxx 10xx xxxx 10xx xxxx)
		{
			$value = (0x1000 * (ord($str[$index]) & 0x0f))
				+ (0x40 * (ord($str[$index+1]) & 0x3f))
				+ (ord($str[$index+2]) & 0x3f);
			return (($value - 0xac00) % 28);
		}

		$index--;
	}

	return true;
}

function koreanEulReul($str) {
	return $str.(finalConsonant($str) ? '을' : '를');
}

function koreanGwaWa($str) {
	return $str.(finalConsonant($str) ? '과' : '와');
}

function koreanEunNeun($str) {
	return $str.(finalConsonant($str) ? '은' : '는');
}

function koreanIGa($str) {
	return $str.(finalConsonant($str) ? '이' : '가');
}

function koreanEuroRo($str) {
	return $str.(finalConsonant($str) ? '으로' : '로');
}

function koreanJosa($str) {
	$str = preg_replace("/([^ ]*)(&amp;을;)/e", "koreanEulReul('\\1')", $str);
	$str = preg_replace("/([^ ]*)(&amp;를;)/e", "koreanEulReul('\\1')", $str);
	$str = preg_replace("/([^ ]*)(&amp;과;)/e", "koreanGwaWa('\\1')",	$str);
	$str = preg_replace("/([^ ]*)(&amp;와;)/e", "koreanGwaWa('\\1')",	$str);
	$str = preg_replace("/([^ ]*)(&amp;은;)/e", "koreanEunNeun('\\1')", $str);
	$str = preg_replace("/([^ ]*)(&amp;는;)/e", "koreanEunNeun('\\1')", $str);
	$str = preg_replace("/([^ ]*)(&amp;이;)/e", "koreanIGa('\\1')", $str);
	$str = preg_replace("/([^ ]*)(&amp;가;)/e", "koreanIGa('\\1')", $str);
	$str = preg_replace("/([^ ]*)(&amp;으로;)/e", "koreanEuroRo('\\1')", $str);
	$str = preg_replace("/([^ ]*)(&amp;로;)/e", "koreanEuroRo('\\1')", $str);
//	$str = preg_replace("/([^ ]*)(&amp;을;)/e", "koreanEulReul('\\1')", $str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;를;)/e", "koreanEulReul('\\1')", $str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;과;)/e", "koreanGwaWa('\\1')",	$str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;와;)/e", "koreanGwaWa('\\1')",	$str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;은;)/e", "koreanEunNeun('\\1')", $str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;는;)/e", "koreanEunNeun('\\1')", $str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;이;)/e", "koreanIGa('\\1')", $str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;가;)/e", "koreanIGa('\\1')", $str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;으로;)/e", "koreanEuroRo('\\1')", $str, -1);
//	$str = preg_replace("/([^ ]*)(&amp;로;)/e", "koreanEuroRo('\\1')", $str, -1);
	return $str;
}

$body = koreanJosa($body);
$title = koreanJosa($title);
$page_title = koreanJosa($page_title);

if (!defined('DATA_DIR')) { exit; }
header('Cache-control: no-cache');
header('Pragma: no-cache');
header('Content-Type: text/html; charset=utf-8');
echo '<?xml version="1.0" encoding="utf-8"?>';
?>

<?php if ($html_transitional) { ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ko" lang="ko">
<?php } else { ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.1//EN" "http://www.w3.org/TR/xhtml11/DTD/xhtml11.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="ko">
<?php } ?>
<head>
 <meta http-equiv="content-type" content="application/xhtml+xml; charset=utf-8" />
 <meta http-equiv="content-style-type" content="text/css" />

<?php if (!$is_read) { ?>
 <meta name="robots" content="NOINDEX,NOFOLLOW" />
<?php } ?>

 <title><?php echo "$title - $page_title" ?></title>
 <link rel="stylesheet" href="skin/default.ja.css" type="text/css" media="screen" charset="utf-8" />
 <link rel="stylesheet" href="skin/print.ja.css" type="text/css" media="print" charset="utf-8" />
<?php
  global $trackback, $referer;
  if ($trackback) {
?>
 <meta http-equiv="Content-Script-Type" content="text/javascript" />
 <script type="text/javascript" src="skin/trackback.js"></script>
<?php } ?>
<?php echo $head_tag ?>
</head>
<body>

<div id="header">
 <a href="<?php echo $modifierlink ?>"><img id="logo" src="pukiwiki.png" width="80" height="80" alt="[PukiWiki]" title="[PukiWiki]" /></a>
 <h1 class="title"><?php echo $page ?></h1>

<?php if ($is_page) { ?>
 <a href="<?php echo "$script?$r_page" ?>"><span class="small"><?php echo "$script?$r_page" ?></span></a>
<?php } ?>

</div>


<div id="navigator">

<?php if ($is_page) { ?>
 [ <a href="<?php echo "$script?$r_page" ?>">다시 읽기</a> ]
 &nbsp;
 [ <a href="<?php echo "$script?plugin=newpage&amp;refer=$r_page" ?>">새 글</a>
 | <a href="<?php echo $link_edit ?>">고치기</a>
<?php   if ($is_read and $function_freeze) { ?>
<?php     if ($is_freeze) { ?>
 | <a href="<?php echo $link_unfreeze ?>">풀기</a>
<?php     } else { ?>
 | <a href="<?php echo $link_freeze ?>">잠그기</a>
<?php     } ?>
<?php   } ?>

 | <a href="<?php echo $link_diff ?>">차이</a>

<?php   if ((bool)ini_get('file_uploads')) { ?>
 | <a href="<?php echo $link_upload ?>">첨부</a>
<?php   } ?>

 ]
 &nbsp;
<?php } ?>

 [ <a href="<?php echo $link_top ?>">대문</a>
 | <a href="<?php echo $link_list ?>">목록</a>

<?php if (arg_check('list')) { ?>
 | <a href="<?php echo $link_filelist ?>">파일 목록</a>
<?php } ?>

 | <a href="<?php echo $link_search ?>">찾기</a>
 | <a href="<?php echo $link_whatsnew ?>">바뀐 글</a>

<?php if ($do_backup) { ?>
 | <a href="<?php echo $link_backup ?>">백업</a>
<?php } ?>

 | <a href="<?php echo $link_help ?>">도움말</a>
 ]
<?php
  if ($trackback) {
    $tb_id = tb_get_id($_page);
?>
 &nbsp;
 [ <a href="<?php echo "$script?plugin=tb&amp;__mode=view&amp;tb_id=$tb_id" ?>">TrackBack(<?php echo tb_count($_page) ?>)</a> ]
<?php } ?>

<?php
  if ($referer) {
?>
 [ <a href="<?php echo "$script?plugin=referer&amp;page=$r_page" ?>">방문 경로</a> ]
<?php } ?>

</div>
<?php echo $hr ?>


<?php if (arg_check('read') and exist_plugin_convert('menu')) { ?>
<table border="0" style="width:100%">
 <tr>
  <td class="menubar">
   <div id="menubar">
    <?php echo do_plugin_convert('menu') ?>
   </div>
  </td>
  <td valign="top">
   <div id="body"><?php echo $body ?></div>
  </td>
 </tr>
</table>
<?php } else { ?>
<div id="body"><?php echo $body ?></div>
<?php } ?>


<?php if ($notes) { ?>
<div id="note">
<?php echo $notes ?>
</div>
<?php } ?>


<?php if ($attaches) { ?>
<div id="attach">
<?php echo $hr ?>
<?php echo $attaches ?>
</div>
<?php } ?>


<?php echo $hr ?>
<div id="toolbar">

<?php if ($is_page) { ?>
 <a href="<?php echo "$script?$r_page" ?>"><img src="./image/reload.png" width="20" height="20" alt="다시 읽기" title="다시 읽기" /></a>
 &nbsp;
 <a href="<?php echo $script ?>?plugin=newpage"><img src="./image/new.png" width="20" height="20" alt="새 글" title="새 글" /></a>
 <a href="<?php echo $link_edit ?>"><img src="./image/edit.png" width="20" height="20" alt="고치기" title="고치기" /></a>
<?php   if ($is_read and $function_freeze) { ?>
<?php     if ($is_freeze) { ?>
 <a href="<?php echo $link_unfreeze ?>"><img src="./image/unfreeze.png" width="20" height="20" alt="풀기" title="풀기" /></a>
<?php     } else { ?>
 <a href="<?php echo $link_freeze ?>"><img src="./image/freeze.png" width="20" height="20" alt="잠그기" title="잠그기" /></a>
<?php     } ?>
<?php   } ?>
 <a href="<?php echo $link_diff ?>"><img src="./image/diff.png" width="20" height="20" alt="차이" title="차이" /></a>
<?php   if ((bool)ini_get('file_uploads')) { ?>
 <a href="<?php echo $link_upload ?>"><img src="./image/file.png" width="20" height="20" alt="첨부" title="첨부" /></a>
<?php   } ?>
 <a href="<?php echo $link_template ?>"><img src="./image/copy.png" width="20" height="20" alt="복사" title="복사" /></a>
 <a href="<?php echo $link_rename ?>"><img src="./image/rename.png" width="20" height="20" alt="이름 바꾸기" title="이름 바꾸기" /></a>
 &nbsp;
<?php } ?>

 <a href="<?php echo $link_top ?>"><img src="./image/top.png" width="20" height="20" alt="대문" title="대문" /></a>
 <a href="<?php echo $link_list ?>"><img src="./image/list.png" width="20" height="20" alt="목록" title="목록" /></a>
 <a href="<?php echo $link_search ?>"><img src="./image/search.png" width="20" height="20" alt="검색" title="검색" /></a>
 <a href="<?php echo $link_whatsnew ?>"><img src="./image/recentchanges.png" width="20" height="20" alt="바뀐 글" title="바뀐 글" /></a>

<?php if ($do_backup) { ?>
 <a href="<?php echo $link_backup ?>"><img src="./image/backup.png" width="20" height="20" alt="백업" title="백업" /></a>
<?php } ?>

 &nbsp;
 <a href="<?php echo $link_help ?>"><img src="./image/help.png" width="20" height="20" alt="도움말" title="도움말" /></a>
 &nbsp;
 <a href="<?php echo $link_rss ?>"><img src="./image/rss.png" width="36" height="14" alt="바뀐 글의 RSS" title="바뀐 글의 RSS" /></a>
</div>


<?php if ($lastmodified) { ?>
<div id="lastmodified">
 Last-modified: <?php echo $lastmodified ?>
</div>
<?php } ?>


<?php if ($related) { ?>
<div id="related">
 Link: <?php echo $related ?>
</div>
<?php } ?>


<div id="footer">
 Modified by <a href="<?php echo $modifierlink ?>"><?php echo $modifier ?></a>
 <br /><br />
 <?php echo S_COPYRIGHT ?>
 <br />
 Powered by PHP <?php echo PHP_VERSION ?>
 <br /><br />
 HTML convert time to <?php echo $taketime ?> sec.
</div>

</body>
</html>
